<?php
// +----------------------------------------------------------------------
// | [KyPHP System] Copyright (c) 2020 http://www.kuryun.com/
// +----------------------------------------------------------------------
// | [KyPHP] 并不是自由软件,你可免费使用,未经许可不能去掉KyPHP相关版权
// +----------------------------------------------------------------------
// | Author: fudaoji <fdj@kuryun.cn>
// +----------------------------------------------------------------------
/**
 * Created by PhpStorm.
 * Script Name: Addon.php
 * Create: 2020/6/29 15:50
 * Description: 应用公共后台控制器
 * Author: fudaoji<fdj@kuryun.cn>
 */
namespace app\common\controller;

class AddonAdmin extends Addon
{
    protected $adminId;
    protected $adminInfo;
    protected $mpInfo = [];
    protected $needAdminLogin = true;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->needAdminLogin && $this->isLogin();
    }

    /**
     * check if login
     * Author: fudaoji<fdj@kuryun.cn>
     */
    protected function isLogin(){
        $this->adminId = (int)session("adminId");
        $this->adminInfo = model("common/admin")->getOne($this->adminId);
        if (empty($this->adminInfo)) {
            $this->error('请先登录！', url('admin/auth/login'));
        }
        if(! model('common/adminAddon')->total(['addon' => $this->addonName, 'uid' => $this->adminId, 'deadline' => ['gt', time()]], 1)){
            $this->error('应用未开通或已到期', url('system/store/myapps'));
        }
    }
}